//audio
datablock AudioProfile(M79ThumperFireSound)
{
   filename    				= "./m79_fire.wav";
   description 				= AudioDefault3d;
   preload 					= true;
};
datablock AudioProfile(M79ThumperExplodeSound)
{
   filename    				= "./m79_splode.wav";
   description 				= AudioDefault3d;
   preload 					= true;
};
datablock AudioProfile(M79ThumperOpenSound)
{
   filename   	 			= "./m79_open.wav";
   description 				= AudioClose3d;
   preload 					= true;
};
datablock AudioProfile(M79ThumperInsertSound)
{
   filename    				= "./m79_insert.wav";
   description 				= AudioClose3d;
   preload 					= true;
};
datablock AudioProfile(M79ThumperCloseSound)
{
   filename    				= "./m79_close.wav";
   description 				= AudioClose3d;
   preload 					= true;
};
datablock DebrisData(M79Thumper40mmCasing)
{
	shapeFile 				= "./case_40mm.dts";
	lifetime 				= 10.0;
	minSpinSpeed 			= -100.0;
	maxSpinSpeed 			= 100.0;
	elasticity 				= 0.5;
	friction 				= 0.1;
	numBounces 				= 3;
	staticOnMaxBounce 		= false;
	snapOnMaxBounce 		= false;
	fade 					= true;

	gravModifier 			= 4;
};
//muzzle flash effects
datablock ParticleData(M79ThumperFlashParticle)
{
	dragCoefficient     	= 1;
	gravityCoefficient  	= 0.0;
	inheritedVelFactor  	= 0.2;
	constantAcceleration 	= 0.0;
	lifetimeMS          	= 25;
	lifetimeVarianceMS  	= 10;
	textureName         	= "base/data/particles/cloud";
	spinSpeed				= 10.0;
	spinRandomMin			= -500.0;
	spinRandomMax			= 500.0;
	colors[0]     			= "1.0 0.4 0.1 1.0";
	colors[1]     			= "0.5 0.2 0.0 0.0";
	sizes[0]      			= 1.0;
	sizes[1]      			= 0.5;

	useInvAlpha 			= false;
};
datablock ParticleEmitterData(M79ThumperFlashEmitter)
{
   ejectionPeriodMS 		= 3;
   periodVarianceMS 		= 0;
   ejectionVelocity 		= 1.0;
   velocityVariance 		= 1.0;
   ejectionOffset   		= 0.0;
   thetaMin         		= 0;
   thetaMax         		= 90;
   phiReferenceVel  		= 0;
   phiVariance      		= 360;
   overrideAdvance 			= false;
   particles 				= "M79ThumperFlashParticle";

   uiName 					= "M79 Thumper Muzzleflash";
};

datablock ParticleData(M79ThumperSmokeParticle)
{
	dragCoefficient      	= 5;
	gravityCoefficient   	= -0.5;
	inheritedVelFactor   	= 0.2;
	constantAcceleration 	= 0.0;
	lifetimeMS           	= 300;
	lifetimeVarianceMS   	= 250;
	textureName          	= "base/data/particles/cloud";
	spinSpeed				= 10.0;
	spinRandomMin			= -500.0;
	spinRandomMax			= 500.0;

	colors[0]     			= "0.1 0.1 0.1 0.0";
	colors[1]     			= "0.2 0.2 0.2 0.5";
	colors[2]     			= "0.2 0.2 0.2 0.0";

	sizes[0]      			= 0.25;
	sizes[1]      			= 1.0;
	sizes[2]      			= 1.75;

	times[0] 				= 0.0;
	times[1] 				= 0.5;
	times[2] 				= 1.0;

	useInvAlpha 			= false;
};
datablock ParticleEmitterData(M79ThumperSmokeEmitter)
{
	ejectionPeriodMS 		= 5;
	periodVarianceMS 		= 0;
	ejectionVelocity 		= 10.0;
	velocityVariance 		= 0.0;
	ejectionOffset   		= 0.0;
	thetaMin         		= 0;
	thetaMax         		= 25;
	phiReferenceVel  		= 0;
	phiVariance      		= 360;
	overrideAdvance 		= false;
	particles 				= "M79ThumperSmokeParticle";

	uiName 					= "M79 Thumper Smoke";
};

//bullet trail effects
datablock ParticleData(M79ThumperTrailParticle)
{
	dragCoefficient      	= 3;
	gravityCoefficient   	= -0.0;
	inheritedVelFactor   	= 0.15;
	constantAcceleration 	= 0.0;
	lifetimeMS           	= 1000;
	lifetimeVarianceMS   	= 805;
	textureName          	= "base/data/particles/cloud";
	spinSpeed				= 10.0;
	spinRandomMin			= -150.0;
	spinRandomMax			= 150.0;
	colors[0]     			= "1.0 1.0 0.0 0.4";
	colors[1]     			= "1.0 0.2 0.0 0.5";
	colors[2]     			= "0.20 0.20 0.20 0.3";
	colors[3]     			= "0.0 0.0 0.0 0.0";

	sizes[0]      			= 0.125;
	sizes[1]      			= 0.5;
	sizes[2]      			= 0.25;
	sizes[3]      			= 0.0;

	times[0] 				= 0.0;
	times[1] 				= 0.05;
	times[2] 				= 0.3;
	times[3] 				= 1.0;

	useInvAlpha 			= false;
};
datablock ParticleEmitterData(M79ThumperTrailEmitter)
{
   ejectionPeriodMS 		= 5;
   periodVarianceMS 		= 1;
   ejectionVelocity 		= 0.25;
   velocityVariance 		= 0.0;
   ejectionOffset   		= 0.0;
   thetaMin         		= 0;
   thetaMax         		= 90;
   phiReferenceVel  		= 0;
   phiVariance      		= 360;
   overrideAdvance 			= false;
   particles 				= "M79ThumperTrailParticle";

   uiName 					= "M79 Thumper Trail";
};
datablock ParticleData(M79ThumperExplosionParticle)
{
	dragCoefficient      	= 2;
	gravityCoefficient   	= 0.5;
	inheritedVelFactor   	= 0.2;
	constantAcceleration 	= 0.0;
	lifetimeMS           	= 3000;
	lifetimeVarianceMS   	= 400;
	textureName          	= "base/data/particles/cloud";
	spinSpeed				= 10.0;
	spinRandomMin			= -50.0;
	spinRandomMax			= 50.0;
	colors[0]     			= "0.8 0.8 0.8 0.3";
	colors[1]     			= "0.6 0.6 0.6 0.0";
	sizes[0]      			= 5.0;
	sizes[1]      			= 12.5;

	useInvAlpha 			= true;
};
datablock ParticleEmitterData(M79ThumperExplosionEmitter)
{
   ejectionPeriodMS 		= 3;
   periodVarianceMS 		= 0;
   ejectionVelocity 		= 10;
   velocityVariance 		= 1.0;
   ejectionOffset   		= 3.0;
   thetaMin         		= 89;
   thetaMax         		= 90;
   phiReferenceVel  		= 0;
   phiVariance      		= 360;
   overrideAdvance 			= false;
   particles 				= "M79ThumperExplosionParticle";

   uiName 					= "M79 Thumper Smoke 1";
};
datablock ParticleData(M79ThumperExplosion2Particle)
{
	dragCoefficient      	= 0;
	gravityCoefficient   	= 3.0;
	inheritedVelFactor   	= 0.2;
	constantAcceleration 	= 0.0;
	lifetimeMS           	= 1500;
	lifetimeVarianceMS   	= 400;
	textureName          	= "base/data/particles/cloud";
	spinSpeed				= 10.0;
	spinRandomMin			= -50.0;
	spinRandomMax			= 50.0;
	
	colors[0]     			= "0.8 0.8 0.8 0.3";
	colors[1]     			= "0.6 0.6 0.6 0.0";
	
	sizes[0]      			= 5.0;
	sizes[1]      			= 12.5;

	useInvAlpha 			= true;
};
datablock ParticleEmitterData(M79ThumperExplosion2Emitter)
{
	lifetimeMS				= 25;
	ejectionPeriodMS 		= 3;
	periodVarianceMS 		= 0;
	ejectionVelocity 		= 20;
	velocityVariance 		= 10.0;
	ejectionOffset   		= 0.0;
	thetaMin         		= 0;
	thetaMax         		= 15;
	phiReferenceVel  		= 0;
	phiVariance      		= 360;
	overrideAdvance 		= false;
	particles 				= "M79ThumperExplosion2Particle";

	uiName 					= "M79 Thumper Smoke 2";
};
datablock ParticleData(M79ThumperExplosion3Particle)
{
	dragCoefficient     	= 0.5;
	gravityCoefficient  	= 3.0;
	inheritedVelFactor  	= 0.2;
	constantAcceleration 	= 0.0;
	spinRandomMin 			= -250;
	spinRandomMax 			= 250;
	lifetimeMS          	= 3000;
	lifetimeVarianceMS  	= 300;

	textureName          	= "base/data/particles/chunk";
	
	colors[0]				= "0.0 0.0 0.0 1.0";
	colors[1]     			= "0.0 0.0 0.0 0.0";
	
	sizes[0]      			= 0.7;
	sizes[1]      			= 0.8;

	useInvAlpha 			= true;
};
datablock ParticleEmitterData(M79ThumperExplosion3Emitter)
{
	lifetimeMS				= 25;
	ejectionPeriodMS 		= 4;
	periodVarianceMS 		= 0;
	ejectionVelocity 		= 15;
	velocityVariance 		= 15;
	ejectionOffset   		= 0.0;
	thetaMin         		= 0;
	thetaMax         		= 25;
	phiReferenceVel  		= 0;
	phiVariance      		= 360;
	overrideAdvance 		= false;
	particles 				= "M79ThumperExplosion3Particle";

	uiName 					= "M79 Thumper Debris";
};
datablock ParticleData(M79ThumperExplosionFlashParticle)
{
	dragCoefficient      	= 8;
	gravityCoefficient  	= -0.5;
	inheritedVelFactor   	= 0.2;
	constantAcceleration 	= 0.0;
	lifetimeMS           	= 40;
	lifetimeVarianceMS   	= 10;
	textureName          	= "base/data/particles/cloud";
	spinSpeed				= 10.0;
	spinRandomMin			= -500.0;
	spinRandomMax			= 500.0;
	colors[0]     			= "1 0.5 0.2 0.5";
	colors[1]     			= "0.9 0.1 0.0 0.0";
	sizes[0]      			= 8;
	sizes[1]      			= 13;

	useInvAlpha 			= false;
};
datablock ParticleEmitterData(M79ThumperExplosionFlashEmitter)
{
	lifeTimeMS 				= 50;

	ejectionPeriodMS		= 1;
	periodVarianceMS 		= 0;
	ejectionVelocity 		= 5;
	velocityVariance 		= 0.0;
	ejectionOffset   		= 3.0;
	thetaMin         		= 0;
	thetaMax         		= 180;
	phiReferenceVel  		= 0;
	phiVariance      		= 360;
	overrideAdvance 		= false;
	particles 				= "M79ThumperExplosionFlashParticle";

	uiName 					= "M79 Thumper Flash";
};

datablock ParticleData(M79ThumperExplosionSparksParticle)
{

	dragCoefficient      	= 0;
	gravityCoefficient  	= 2.5;
	inheritedVelFactor   	= 0.2;
	constantAcceleration 	= 0.0;
	lifetimeMS           	= 500;
	lifetimeVarianceMS   	= 100;
	textureName          	= "base/data/particles/cloud";
	spinSpeed				= 10.0;
	spinRandomMin			= -500.0;
	spinRandomMax			= 500.0;
	colors[0]     			= "1 0.5 0.2 0.5";
	colors[1]     			= "0.9 0.1 0.0 0.0";
	sizes[0]      			= 0.25;
	sizes[1]      			= 0.5;

	useInvAlpha 			= false;
};
datablock ParticleEmitterData(M79ThumperExplosionSparksEmitter)
{
	lifeTimeMS 				= 50;

	ejectionPeriodMS		= 1;
	periodVarianceMS 		= 0;
	ejectionVelocity 		= 35;
	velocityVariance 		= 0.0;
	ejectionOffset   		= 3.0;
	thetaMin         		= 0;
	thetaMax         		= 90;
	phiReferenceVel  		= 0;
	phiVariance      		= 360;
	overrideAdvance 		= false;
	particles 				= "M79ThumperExplosionSparksParticle";

	uiName 					= "M79 Thumper Sparks";
};
datablock ExplosionData(M79ThumperExplosion)
{
	//explosionShape 		= "";
	soundProfile 			= M79ThumperExplodeSound;

	lifeTimeMS 				= 150;

	particleEmitter 		= M79ThumperExplosionEmitter;
	particleDensity 		= 10;
	particleRadius 			= 0.2;

	emitter[0] 				= M79ThumperExplosionFlashEmitter;
	emitter[1]				= M79ThumperExplosionSparksEmitter;
	emitter[2] 				= M79ThumperExplosion2Emitter;
	emitter[3] 				= M79ThumperExplosion3Emitter;

	faceViewer     			= true;
	explosionScale 			= "1 1 1";

	shakeCamera 			= true;
	camShakeFreq		 	= "10.0 11.0 10.0";
	camShakeAmp 			= "3.0 10.0 3.0";
	camShakeDuration 		= 1.5;
	camShakeRadius 			= 30.0;

	// Dynamic light
	lightStartRadius 		= 5;
	lightEndRadius 			= 20;
	lightStartColor 		= "1.0 0.35 0.0 1.0";
	lightEndColor 			= "0.0 0.0 0.0 0.0";

	damageRadius 			= 6;
	radiusDamage 			= 125;

	impulseRadius 			= 8;
	impulseForce 			= 4000;
};

AddDamageType("M79ThumperDirect",   '<bitmap:add-ons/Weapon_M79Thumper/CI_m79> %1',    '%2 <bitmap:add-ons/Weapon_M79Thumper/CI_m79> %1',1,1);
AddDamageType("M79ThumperRadius",   '<bitmap:add-ons/Weapon_M79Thumper/CI_m79> %1',    '%2 <bitmap:add-ons/Weapon_M79Thumper/CI_m79> %1',1,0);
datablock ProjectileData(M79ThumperProjectile)
{
   projectileShapeName 		= "./proj_40mm.dts";
   directDamage        		= 30;
   directDamageType 		= $DamageType::M79ThumperDirect;
   radiusDamageType 		= $DamageType::M79ThumperRadius;
   impactImpulse	   		= 1000;
   verticalImpulse	   		= 1000;
   explosion           		= M79ThumperExplosion;
   particleEmitter     		= M79ThumperTrailEmitter;

   brickExplosionRadius 	= 3;
   brickExplosionImpact 	= false;          //destroy a brick if we hit it directly?
   brickExplosionForce  	= 30;             
   brickExplosionMaxVolume 	= 30;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 60;  //max volume of bricks that we can destroy if they aren't connected to the ground (should always be >= brickExplosionMaxVolume)

   muzzleVelocity      		= 65;
   velInheritFactor    		= 0.25;

   armingDelay         		= 0;
   lifetime            		= 16000;
   fadeDelay           		= 3500;
   bounceElasticity    		= 0.5;
   bounceFriction     		= 0.20;
   isBallistic         		= true;
   gravityMod 				= 1.0;

   hasLight    				= false;

	decal[0] 				= "./explosionBlast.png";  

   uiName 					= "M79 Thumper Projectile";
};

//////////
// item //
//////////
datablock ItemData(M79ThumperItem)
{
	category 				= "Weapon";  // Mission editor category
	className 				= "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile 				= "./m79_item.dts";
	rotate 					= false;
	mass 					= 1;
	density 				= 0.2;
	elasticity 				= 0.2;
	friction 				= 0.6;
	emap 					= false;

	//gui stuff
	uiName 					= "M79 Thumper";
	iconName 				= "./icon_m79";
	doColorShift 			= false;

	 // Dynamic properties defined by the scripts
	image 					= M79ThumperImage;
	canDrop 				= true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(M79ThumperImage)
{
   // Basic Item properties
   shapeFile 				= "./m79.dts";
   emap 					= false;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint 				= 0;
   offset 					= "0 0 0";
   eyeOffset 				= 0; //"0.7 1.2 -0.5";
   rotation 				= eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector 		= true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className 				= "WeaponImage";

   // Projectile && Ammo.
   item 					= M79ThumperItem;
   ammo 					= " ";
   projectile 				= M79ThumperProjectile;
   projectileType 			= Projectile;

	casing 					= M79Thumper40mmCasing;
	shellExitDir        	= "0.0 -1.0 1.0";
	shellExitOffset    	 	= "0 0 0";
	shellExitVariance   	= 15.0;	
	shellVelocity       	= 2.0;

   //melee particles shoot from eye node for consistancy
   melee 					= false;
   //raise your arm up or not
   armReady 				= true;
   minShotTime 				= 700;   //minimum time allowed between shots (needed to prevent equip/dequip exploit)

   doColorShift 			= false;

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     	= "Activate";
	stateTimeoutValue[0]             	= 0.1;
	stateTransitionOnTimeout[0]       	= "Ready";
	stateSound[0]						= weaponSwitchSound;

	stateName[1]                     	= "Ready";
	stateTransitionOnTriggerDown[1]  	= "Fire";
	stateAllowImageChange[1]         	= true;
	stateTransitionOnNoAmmo[1]       	= "NoAmmo";
	stateSequence[1]					= "Ready";

	stateName[2]                    	= "Fire";
	stateTransitionOnTimeout[2]     	= "Smoke";
	stateTimeoutValue[2]            	= 0.05;
	stateFire[2]                   	 	= true;
	stateAllowImageChange[2]       	 	= false;
	stateSequence[2]                	= "Fire";
	stateScript[2]                  	= "onFire";
	stateWaitForTimeout[2]				= true;
	stateEmitter[2]						= M79ThumperFlashEmitter;
	stateEmitterTime[2]					= 0.05;
	stateEmitterNode[2]					= "muzzleNode";
	stateSound[2]						= M79ThumperFireSound;
	stateSequence[2]                	= "Fire";

	stateName[3] 						= "Smoke";
	stateEmitter[3]						= M79ThumperSmokeEmitter;
	stateEmitterTime[3]					= 0.1;
	stateEmitterNode[3]					= "muzzleNode";
	stateTimeoutValue[3]            	= 0.1;
	stateTransitionOnTimeout[3]     	= "Open";
	
	stateName[4]                     	= "Open";
	stateTimeoutValue[4]             	= 0.45;
	stateTransitionOnTimeout[4]       	= "Insert";
	stateSound[4]						= M79ThumperOpenSound;
	stateScript[4]						= "onOpen";
	stateSequence[4]                	= "Open";
	stateEjectShell[4]       	  		= true;

	stateName[5]                     	= "Insert";
	stateTimeoutValue[5]             	= 0.3;
	stateTransitionOnTimeout[5]       	= "Close";
	stateSound[5]						= M79ThumperInsertSound;
	stateScript[5]						= "onInsert";
	stateSequence[5]                	= "Load";

	stateName[6]                     	= "Close";
	stateTimeoutValue[6]             	= 0.25;
	stateTransitionOnTimeout[6]       	= "Ready";
	stateSound[6]						= M79ThumperCloseSound;
	stateScript[6]						= "onClose";
	stateSequence[6]                	= "Close";
};
function M79ThumperImage::onFire(%this,%obj,%slot)
{
	if((%obj.lastFireTime+%this.minShotTime) > getSimTime())
		return;
	%obj.lastFireTime = getSimTime();

	%obj.playThread(2, jump);

	%projectile = %this.projectile;
	%spread = 0.0;
	%shellcount = 1;

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;
}
function M79ThumperImage::onOpen(%this,%obj,%slot)
{
	%obj.playThread(2, shiftDown);
}
function M79ThumperImage::onInsert(%this,%obj,%slot)
{
	%obj.playThread(2, plant);
}
function M79ThumperImage::onClose(%this,%obj,%slot)
{
	%obj.playThread(2, shiftUp);
}
